AX_BX:    
    CLRF STATUS
    MVF  BL,W,ACCE
    SUBF AL,F,ACCE
    MVF  BH,W,ACCE
    SUBC  AH,F,ACCE
    RET
COMFAX:
    comf AL,F,ACCE
    comf AH,F,ACCE
    inf AL,F
    btsS Status,Z
    ret
    inf	AH,F
    RET
    
;==========================
;mul
;========================
16BITMUL16BITU:
     CLRF STATUS
     CLRF EAH
     CLRF EAL
     MVF  AH,W,ACCE
     MVF  MUL_REGH,F,ACCE
     MVF  AL,W,ACCE
     MVF  MUL_REGL,F,ACCE
     
     MVL  010H
     MVF  BUFFER,F,ACCE
 LOOP16U:
     BTSZ  BL,0
     CALL ADD2OPRATION
     CALL RR4F
     DCSZ BUFFER,F,ACCE
     JMP  LOOP16U
     CLRF MUL_REGH
     CLRF MUL_REGL
     RET
 ADD2OPRATION:
   MVF  MUL_REGL,W,ACCE
   ADDF EAL,F,ACCE
   MVF  MUL_REGH,W,ACCE
   ADDC EAH,F,ACCE
   RET
 RR4F:
  RRFC EAH,F,ACCE
  RRFC EAL,F,ACCE
  RRFC AH,F,ACCE
  RRFC AL,F,ACCE
  CLRF	STATUS
  RRFC	BH,F,ACCE
  RRFC	BL,F,ACCE
  CLRF	STATUS
  RET  
;================================
;32/16bit  Fixed Point Divide   
;Equation:<<32/16= 16>>
;			 EAX/CX= AX...DX 
;paramaters : 
;		1.Divided Number  : EAX(EAH,EAL,ah,al) 
;		2.Divisor Number  : CX(CH,CL)
;register:1.EAX,2.AX,3.CX,4.DX,5.DIVTX,6.buffer
;===========================================

32BITDIV16BITU:
     MVL  020H
     mvf buffer,f,acce
     clrf  divh
     clrf  divl
 
divloop32_16u:
      clrf  status
      rlfc  AL,F
      RLFC  AH,F
      RLFC  EAL,F
      RLFC  EAH,F
      RLFC  DIVL,F
      RLFC  DIVH,F
      MVF   DIVL,W,ACCE
      MVF   DL,F,ACCE
      MVF   DIVH,W,ACCE
      MVF   DH,F,ACCE
      CALL  DX_CX
      BTSS  STATUS,C
      JMP   DIVLS32_16U
      MVF   DL,W,ACCE
      MVF   DIVL,F,ACCE
      
      MVF   DH,,ACCE
      MVF   DIVH,F,ACCE
      INF   AL,F
DIVLS32_16U:
      DCSZ  BUFFER,1
      JMP   divloop32_16u
      CLRF  STATUS
      MVF   DIVL,W,ACCE
      MVF   DL,F,ACCE
      MVF   DIVH,W,ACCE
      MVF   DH,F,ACCE
      RET
      

DX_CX:
     MVF CL,W,ACCE
     SUBF DL,F,ACCE
     MVF CH,W,ACCE
     SUBC DH,F,ACCE
      RET